/*
 * $Id: asm.h,v 1.3 93/06/21 13:38:00 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 * Error codes and messages used in asm.c.
 *
 * Written by
 *   Vesa-Matti Puro (vmp@lut.fi)
 *
 * $Log:	asm.h,v $
 * Revision 1.3  93/06/21  13:38:00  jopi
 *  X64 version 0.2 PL 0
 * 
 * Revision 1.2  93/06/21  13:07:39  jopi
 * *** empty log message ***
 * 
 * Revision 1.3  1993/06/13  08:39:52  sonninen
 * *** empty log message ***
 *
 * Revision 1.2  1993/06/13  08:19:36  sonninen
 * *** empty log message ***
 *
 *
 */

#define NUM_OF_MNEMS 56
#define TOTAL_CODES 256
#define MAXARG 17

 /* optimise searching a little */

#define OP_IMPL_MIN  0x00
#define OP_IMPL_MAX  0xfa
#define OP_IMPL_SPC  0x02

#define OP_IMM_MIN   0x09
#define OP_IMM_MAX   0xeb
#define OP_IMM_SPC   0x01	/* not used */

#define OP_ACCU_MIN  0x0a
#define OP_ACCU_MAX  0x6a
#define OP_ACCU_SPC  0x20

#define OP_ABS_MIN   0x0c
#define OP_ABS_MAX   0xff
#define OP_ABS_SPC   0x04

#define SYMBOL_WORD  1
#define SYMBOL_SET   2
#define SYMBOL_FOUND 4
#define SYMBOL_VALID 8
#define SYMBOL_BALL   (SYMBOL_SET | SYMBOL_FOUND | SYMBOL_VALID)
#define SYMBOL_WALL   (SYMBOL_WORD | SYMBOL_SET | SYMBOL_FOUND | SYMBOL_VALID)

 /* define 'mode' */

#define MODE_HEX     1
#define MODE_SYMBOL  2
#define MODE_QUOTE   4
#define MODE_BYTE    8	/* reserve one byte  */
#define MODE_WORD   16	/* reserve two bytes */
#define MODE_MON   (1 << 5)
#define MODE_ASM   (1 << 6)
#define MODE_QUIET (1 << 7)
#define MODE_FILE  (1 << 8)
#define MODE_PASS  (1 << 9)
#define MODE_SKIP  (1 << 10)
#define MODE_QUERY (1 << 11)
#define MODE_SPACE (1 << 12)	/* space terminates calculation (MON) */

#define ERRORS_TO_STOP  20	/* screenfull on terminal */


#define E_ERROR			(512 + 0)
#define E_BAD_IDENTIFIER	(512 + 1)
#define E_SYMBOL_UNDEFINED	(512 + 2)
#define E_SYMBOL_REDEF		(512 + 3)

#define E_LONG_BRANCH		(512 + 4)

#define E_PARAMETER_SYNTAX	(512 + 8)
#define E_TOO_MANY_COMMAS	(512 + 9)
#define E_RIGHT_PARENTHESIS	(512 + 10)
#define E_LEFT_PARENTHESIS	(512 + 11)
#define E_PARENTHESIS		(512 + 12)
#define E_MIXED_XY		(512 + 13)
#define E_MISSING_XY		(512 + 14)
#define E_BAD_INDEX		(512 + 15)


#define EM_ERROR		"Parse error: I don't get it."
#define EM_TOO_MANY_ERRORS	"Keep your filthy fingers off here!"

#define EM_SYMBOL_REDEF 	"Redefinition of '%s' at"
#define EM_LONG_BRANCH		"Branch out of range"

#define EM_PARAMETER_SYNTAX 	"Parameter syntax error."
#define EM_TOO_MANY_COMMAS  	"Too many commas found."
#define EM_RIGHT_PARENTHESIS	"Too many right parenthesis, 1 is maximum."
#define EM_LEFT_PARENTHESIS 	"Too many left parenthesis, 1 is maximum."
#define EM_PARENTHESIS	    	"There isn't equally right and left parenthesis."
#define EM_MIXED_XY         	"Indirect mode indexed both X and Y."


#ifdef FOO
 /* Warnings */
#define EM_		"Undocumented opcode % s used"
#define EM_		"Unrecognised directive % s"
#define EM_		"Value Too large"
#define EM_		"Syntax error"
#define EM_		"Confusing sourcecode"
#endif
