/*
 * $Id: extern.h,v 1.3 93/06/21 13:38:30 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 * Written by
 *   Vesa-Matti Puro (vmp@lut.fi)
 *   Teemu Rantanen (tvr@cs.hut.fi)
 *   Jarkko Sonninen (sonninen@lut.fi)
 *
 * $Log:	extern.h,v $
 * Revision 1.3  93/06/21  13:38:30  jopi
 *  X64 version 0.2 PL 0
 * 
 * Revision 1.2  93/06/21  13:08:15  jopi
 * *** empty log message ***
 * 
 * Revision 1.3  1993/06/13  08:39:52  sonninen
 * *** empty log message ***
 *
 * Revision 1.2  1993/06/13  08:21:50  sonninen
 * *** empty log message ***
 *
 *
 */

#ifdef __cplusplus
#ifdef __STDC__
#undef __STDC__
#endif
#define __STDC__ 0
#endif

extern char *progname;
extern int clength[];

extern BYTE accumulator;
extern BYTE x_register;
extern BYTE y_register;
extern BYTE stack_pointer;
extern BYTE status_register;
extern ADDRESS program_counter;
extern CLOCK clk;

extern int zero_flag;
extern int sign_flag;
extern int overflow_flag;
extern int break_flag;
extern int decimal_flag;
extern int interrupt_flag;
extern int carry_flag;

extern char *ram_name;
extern char *basic_name;
extern char *kernel_name;
extern char *project_dir;

/* debugging */
extern int hexflg;
extern int tstflg;
extern int verflg;
extern int debugflg;
extern int runflg;

/* memory */

extern int module;

extern CLOCK int_clk[];

extern CLOCK next_int_clk;
extern int next_int;

extern BYTE ram[];
extern BYTE kernal_rom[];
extern BYTE basic_rom[];
extern BYTE char_rom[];
extern BYTE *external_rom;
extern BYTE byte;
extern BYTE color_ram[];
extern BYTE vic[];
extern BYTE sid[];
extern BYTE cia1[];
extern BYTE cia2[];
extern BYTE keyarr[];
extern BYTE joy1, joy2;

#ifdef __STDC__
extern BYTE load_rom(ADDRESS a);
extern void save_rom(ADDRESS a, BYTE x);
#else
extern BYTE load_rom();
extern void save_rom();
#endif

/* ram expansion */
#ifdef REU

extern int reuflg;

#ifdef __STDC__
extern void    reset_reuc(char *);
extern void    close_reuc(char *);
extern BYTE    read_reuc(ADDRESS);
extern void    store_reuc(ADDRESS, BYTE);
extern void    reu_dma(int);

#else
extern void    reset_reuc();
extern void    close_reuc();
extern BYTE    read_reuc();
extern void    store_reuc();
extern void    reu_dma();
#endif
#endif

/* screen & keyboard */
extern BYTE *charbase;
extern BYTE *scrbase;
extern BYTE *bitmapbase1;
extern BYTE *bitmapbase2;
extern int yscroll;
extern int xscroll;
extern int vbank;
extern int vmode;

#ifdef __STDC__
extern void (*(memwr[])) (ADDRESS, BYTE);
extern  BYTE(*(memrd[])) (ADDRESS);

extern void (*x_draw_bitmap) (ADDRESS);
extern void (*x_redraw) (void);
#else

extern void (*(memwr[])) ();
extern  BYTE(*(memrd[])) ();

extern void (*x_draw_bitmap) ();
extern void (*x_redraw) ();
#endif

/* C64 performance */
extern int rd[];
extern int wr[];
extern long instructions[];

/* traps */
#ifdef __STDC__
extern int trap_handler(void);
extern void initialize_traps(void);
/*extern int set_trap(trap_r *t);*/
#else
extern int trap_handler();
extern void initialize_traps();
extern int set_trap();
#endif
 
/* floppy disk emulation */
#ifdef __STDC__

extern void initialize_serial ( void );
extern int attach_serial_device(int, char   *, 
				int (*)(BYTE * , int), 
				int (*)(BYTE , int), 
				int (*)(char *, int , int), 
				int (*)(int), 
				void (*)(int));

#else /* __STDC__ */

extern void initialize_serial (/* void */);
extern int attach_serial_device (/* int device, char *name, int (*getf) (), int (*putf) (), int (*openf) (), int (*closef) (), void (*flushf) () */);

#endif /* __STDC__ */

#ifdef NEW_TIMER_CODE
/* experimental timer code */
#ifdef __STDC__
extern void find_next_alarm(void);
extern void alarm_handler(void);
extern void set_alarm(int alarm, CLOCK value, void (*func)(int), int);
extern int  new_alarm(void);
extern void clear_alarm(int alarm);
extern void update_intr_alarm(void);  /* old intr support kludge */
extern CLOCK next_alarm_clk;
#else
extern void find_next_alarm();
extern void alarm_handler();
extern void set_alarm();
extern int  new_alarm();
extern void clear_alarm();
extern void update_intr_alarm();  /* old intr support kludge */
extern CLOCK next_alarm_clk;
#endif
#endif /* NEW_TIMER_CODE */

#include "proto.h"

#define sprint_status()	 sprint_binary(GET_SR())
