/*
 * $Id: macro.h,v 1.3 93/06/21 13:38:33 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 * Written by
 *   Vesa-Matti Puro (vmp@lut.fi)
 *   Jarkko Sonninen (sonninen@lut.fi)
 *
 * $Log:	macro.h,v $
 * Revision 1.3  93/06/21  13:38:33  jopi
 *  X64 version 0.2 PL 0
 * 
 * Revision 1.2  93/06/21  13:08:18  jopi
 * *** empty log message ***
 * 
 * Revision 1.3  1993/06/13  08:39:52  sonninen
 * *** empty log message ***
 *
 * Revision 1.2  1993/06/13  08:21:50  sonninen
 * *** empty log message ***
 *
 *
 */

#include "vmachine.h"

#define LOAD(a)      		memrd[(a)>>12](a)
#define LOAD_ZERO(a) 		ram[(a)&0xff]
#define LOAD_ADDR(a)		(LOAD(a+1)<<8)+LOAD(a)
#define LOAD_ZERO_ADDR(a)	(ram[((a)+1)&0xff]<<8)+ram[(a)&0xff]

#define STORE(a,b)     	 	memwr[(a)>>12]((a),(b))
/*#define STORE_ZERO(a,b)		ram[(a)&0xff]=(b)*/
/* #define STORE_ZERO(a,b)		memwr[0]((a),(b)) */
/* niin tuo STORE ZERO taytyy tietenkin muuttaa: */
#define STORE_ZERO(a,b)         memwr[0]((a)&0xff,(b))



#define PUSH(b) 		ram[SP+0x100]=(b),SP--
#define PULL()			ram[(++SP)+0x100]

#define UPPER(ad)		(((ad)>>8)&0xff)
#define LOWER(ad)		((ad)&0xff)


#ifdef _AIX
#define REL_ADDR(pc,src) 	(pc+(int)((signed char)src))
#else
#define REL_ADDR(pc,src) 	(pc+(int)((char)src))
#endif
/*#define REL_ADDR(pc,src) 	(pc+((src&0x80)?-1-(src^0xff):src))*/


#define SET_SIGN(a)		(SF=(a)&SIGN)
#define SET_ZERO(a)		(ZF=!(a))
#define SET_CARRY(a)  		(CF=(a))

#define SET_INTERRUPT(a)	(IF=(a))
#define SET_DECIMAL(a)		(DF=(a))
#define SET_OVERFLOW(a)		(OF=(a))
#define SET_BREAK(a)		(BF=(a))

#define SET_SR(a)		(SF=(a) & SIGN,\
				 ZF=(a) & ZERO,\
				 CF=(a) & CARRY,\
				 IF=(a) & INTERRUPT,\
				 DF=(a) & DECIMAL,\
				 OF=(a) & OVERFLOW,\
				 BF=(a) & BREAK)

#define GET_SR()		((SF ? SIGN : 0) |\
				 (ZF ? ZERO : 0) |\
				 (CF ? CARRY : 0) |\
				 (IF ? INTERRUPT : 0) |\
				 (DF ? DECIMAL : 0) |\
				 (OF ? OVERFLOW : 0) |\
				 (BF ? BREAK : 0) | NOTUSED)

#define IF_SIGN()		SF
#define IF_ZERO()		ZF
#define IF_CARRY()		CF
#define IF_INTERRUPT()		IF
#define IF_DECIMAL()		DF
#define IF_OVERFLOW()		OF
#define IF_BREAK()		BF
