/*
 * $Id: mnemonics.h,v 1.3 93/06/21 13:38:45 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 * This file contains #defines for instruction mnemonics and ass()
 * assebler commands.
 *
 * Written by
 *   Vesa-Matti Puro (vmp@lut.fi)
 *   Jouko Valta (jopi@stekt.oulu.fi)
 *
 * $Log:	mnemonics.h,v $
 * Revision 1.3  93/06/21  13:38:45  jopi
 *  X64 version 0.2 PL 0
 * 
 * Revision 1.2  93/06/21  13:08:28  jopi
 * *** empty log message ***
 * 
 * Revision 1.3  1993/06/13  08:39:52  sonninen
 * *** empty log message ***
 *
 * Revision 1.2  1993/06/13  08:21:50  sonninen
 * *** empty log message ***
 *
 *
 */

/* INSTRUCTION MNEMONICS. */

#define ADC    "ADC"
#define AND    "AND"
#define ASL    "ASL"
#define BCC    "BCC"
#define BCS    "BCS"
#define BEQ    "BEQ"
#define BIT    "BIT"
#define BMI    "BMI"
#define BNE    "BNE"
#define BPL    "BPL"
#define BRK    "BRK"
#define BVC    "BVC"
#define BVS    "BVS"
#define CLC    "CLC"
#define CLD    "CLD"
#define CLI    "CLI"
#define CLV    "CLV"
#define CMP    "CMP"
#define CPX    "CPX"
#define CPY    "CPY"
#define DEC    "DEC"
#define DEX    "DEX"
#define DEY    "DEY"
#define EOR    "EOR"
#define INC    "INC"
#define INX    "INX"
#define INY    "INY"
#define JMP    "JMP"
#define JSR    "JSR"
#define LDA    "LDA"
#define LDX    "LDX"
#define LDY    "LDY"
#define LSR    "LSR"
#define NOOP   "NOOP"
#define NOP    "NOP"
#define ORA    "ORA"
#define PHA    "PHA"
#define PHP    "PHP"
#define PLA    "PLA"
#define PLP    "PLP"
#define ROL    "ROL"
#define ROR    "ROR"
#define RTI    "RTI"
#define RTS    "RTS"
#define SBC    "SBC"
#define SEC    "SEC"
#define SED    "SED"
#define SEI    "SEI"
#define STA    "STA"
#define STX    "STX"
#define STY    "STY"
#define TAX    "TAX"
#define TAY    "TAY"
#define TSX    "TSX"
#define TXA    "TXA"
#define TXS    "TXS"
#define TYA    "TYA"

#ifndef NO_UNDOC_CMDS
#define ANC    "ANC"
#define ANE    "ANE"
#define ARR    "ARR"
#define ASR    "ASR"
#define DCP    "DCP"
#define ISB    "ISB"
#define JAM    "JAM"
#define LAS    "LAS"
#define LAX    "LAX"
#define LXA    "LXA"
 /* NOOP undefined NOP */
#define RLA    "RLA"
#define RRA    "RRA"
#define SAX    "SAX"
#define USBC   "USBC"	/* undefined SBC */
#define SBX    "SBX"
#define SHA    "SHA"
#define SHS    "SHS"
#define SHX    "SHX"
#define SHY    "SHY"
#define SLO    "SLO"
#define SRE    "SRE"

#else
#define ANC    NOOP
#define ANE    NOOP
#define ARR    NOOP
#define ASR    NOOP
#define DCP    NOOP
#define ISB    NOOP
#define JAM    NOOP
#define LAS    NOOP
#define LAX    NOOP
#define LXA    NOOP
 /* NOOP undefined NOP */
#define RLA    NOOP
#define RRA    NOOP
#define SAX    NOOP
#define USBC   NOOP
#define SBX    NOOP
#define SHA    NOOP
#define SHS    NOOP
#define SHX    NOOP
#define SHY    NOOP
#define SLO    NOOP
#define SRE    NOOP
#endif
