/*
 * $Id: serial.h,v 1.3 93/06/21 13:39:24 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 *
 *
 * Written by
 *   Teemu Rantanen (tvr@cs.hut.fi)
 *
 * $Log:	serial.h,v $
 * Revision 1.3  93/06/21  13:39:24  jopi
 *  X64 version 0.2 PL 0
 * 
 * Revision 1.2  93/06/21  13:09:25  jopi
 * *** empty log message ***
 * 
 * Revision 1.3  1993/06/13  08:39:52  sonninen
 * *** empty log message ***
 *
 * Revision 1.2  1993/06/13  08:21:50  sonninen
 * *** empty log message ***
 *
 *
 */

#define SERIAL_OK		0
#define SERIAL_FILE_NOT_FOUND	4
#define SERIAL_ERROR		4
#define SERIAL_EOF		64

#ifdef __STDC__
typedef struct serial_s
{
    int inuse;
    int isopen;
    char *name;				/* name of the device */
    int (*getf)(BYTE *, int);		/* serial read function */
    int (*putf)(BYTE, int);		/* serial write function */
    int (*openf)(char *, int, int);	/* serial open function */
    int (*closef)(int);			/* serial close function */
    void (*flushf)(int);		/* tell device that write completed */
} serial_t;

#else
typedef struct serial_s
{
    int inuse;
    int isopen;
    char *name;			/* name of the device */
    int (*getf)();		/* serial read function */
    int (*putf)();		/* serial write function */
    int (*openf)();		/* serial open function */
    int (*closef)();		/* serial close function */
    void (*flushf)();		/* tell device that write completed */
} serial_t;

#endif
