.TH X64  N  "17 June 1993" "X Version 11" "DEMOS"
.SH NAME
x64,c1541 \- Commodore 64 Emulator And Program Development System for X display
.SH SYNOPSIS
.B x64
[-A] [-a] [-g] [-h] [-t] [-v] [-f \fIdisk\fR] [-l \fIfilename\fR]
[-p \fIpath\fR] [-e \fIexromfile\fR] [-m \fIn\fR] [-r [[\fIreufile\fR]]
[\fImemory_address\fR]

.B c1541 \fIoption\fR \fIdiskname\fR [\fIparameters\fR]

.SH DESCRIPTION
.IR X64
is a powerful Commodore 64 emulator with
a Machine Language Monitor built-in.
For the best possible compatibility
.IR X64
emulates the hardware so that the original basic and kernel
routines can be used. Also cartridge support and disk drive
are included. Thus, 
.IR X64
is capable to run most of the normal C64 programs which do not
require other peripherals nor high speed computing like sound
and rasterline effects.

.SH OPTIONS
.TP 8
.B \-A
causes
.IR X64
to store automatically ram to file "ram" for
later use when exiting the emulator.
.TP
.B \-a
starts the monitor upon initialization.
.TP
.B \-e \fIexrom\fR
specify the file to be loaded to cartridge ROM slot with -m option.
As default the name is "exrom".
.TP
.B \-f \fIdisk\fR
attaches specified file containing floppy disk image.
.TP
.B \-g
select debug mode.
.TP\-h
toggle default number base to 10 or 16. Default is hexadecimal.
.TP
.B \-l \fIc64_program_name\fR
load a program into ram. There has to be the start address
included in the beginning of the program.
.TP
.B \-m \fIn\fR
select the memory area where the \fIexrom\fR module is located:
.br
1 = 8000-9FFF
2 = A000-BFFF
3 = 8000-BFFF
.TP 
.B \-p \fIpath\fR 
set directory path for project directory.
.TP 
.B \-r [\fIreufile\fR]
If installed in compilation, activates the RAM Expansion Unit and
specifies the filename for RAM image of the REU.
Existing file is loaded to memory upon startup.
The default filename is "reu".
.TP
.B \-v
select verbose mode.
.TP
.B \fIaddress\fR
address of the power-up initialization routine. The default
is RESET (FCE2).
With a BASIC program being loaded, better result may be achieved by
using the BASIC warm start vector (FE66) instead.
.br
This must be the last argument on the command line.
.SH USAGE
.SS Keyboard Layout
.TP 8
The following keys have special meaning for \fIX64\fR:
.TP 16
.B "F1 F2 F3 F4 F5 F6 F7 F8"
The C64 function keys
.TP
.B  asciicircum or asciitilde
up arrow (on US and scandinavian keyboards respectively).
.TP
.BI underscore
right arrow
.TP
.BI bar
Pound Sign
.TP
.BI Backspace
Inst
.TP
.BI Linefeed
Shifted Return
.TP
.BI Control_L
Control
.TP
.BI Alt_L
CBM Key (Press down Left Shift and then Alt to change character set.)
.TP
.BI Escape
STOP
.TP
.BI Tab
Restore
.TP
.BI Shift_R
The Right Shift key can be used to achieve characters shifted on the actual
keyboard but unshifted on the C64 one.
.SS Joystick
Currently joystick #1 can be found on the keys Up, Down,
Left and Right of the Numerical Keypad while Enter is the Fire Button.
That works when pointer is in control window. In main window these
keys works as normal cursor keys.
.SS Mouse
The left mouse button while focus is in control window 
may be used to toggle on and off \fIdebug mode\fR.
.pp
A press of the middle button halts the emulator and starts the \fIMonitor\fR.
.pp
The right mouse button will open and close a
.IR control
.IR window,
which contains some useful gadgets as well as some debug information.
.SS Control Window
.TP 10
.BI Trace
causes
.IR x64
to update assembly window each time a new intruction is to be run.
.TP
.BI Stop
enforces the C64 emulator to halt.
.TP
.BI Exit
This gadget, of course, quits the program.
.TP
 Two additional functions are available while emulator is halted.
.TP
.BI Cont
resumes the emulator.
.TP
.BI Step
CPU performs the next consecutive machine language instruction.
.LP
The upper left part of the control window displays the 6510 registers with
their current content.
.br
The right side of the control window displays the part of program the CPU
is executing.
.br
In the lower left corner are gadgets for controling the emulator.
.SH MONITOR
The
.IR Monitor
has command line editor and history utility controlled by
the cursor keys.
.pp
The following monitor commands are implemented:
.PD 1
.TP 8
.B "#%&$"
Base conversion prefixes
.TP
.B ":" \fIaddr\fR "\fIbytes|'string'\fR"
Write data into memory.
.TP
.B ";" [\fIregisters\fR]
Same as 'registers'
.TP
.B \? [\fItopic\fR]
Help
.TP
.B asm [\fIaddr\fR]
Enters to line interpreter. Use `.' or `x' to return command mode.
.br
The following syntax is used:
.br
[\fIaddr\fR] \fImnemonic\fR [\fIoperand\fR]
.TP
.B break [\fIstart\fR] [\fIend\fR]
Set up breakpoints (region). New timer code only.
.TP
.B call [\fIaddr\fR]
Run code at address specified.
.TP
.B clear \fIstart\fR [\fIend\fR]
Clear breakpoints in specified region. New timer code only.
.TP
.B compare \fIstart\fR \fIend|+len\fR "\fItarget\fR"
.TP
.B disassemble [\fIaddr\fR] [\fIend|+len\fR]
.TP
.B dump [\fIfilename\fR]
Save ram image to a file.
.TP
.B fill \fIstart\fR \fIend|+len\fR "\fIbytes|'string'\fR"
.TP
.B floppy [\fIimagename\fR]
Attach floppy disk image file \fIimagename\fR for use.
.TP
.B help [\fItopic\fR]
.TP
.B hunt \fIstart\fR \fIend|+len\fR "\fIbytes|'string'\fR"
.TP
.B image [\fIaddr\fR] [\fIend|+len\fR]
Displays memory dump in bit format.
.TP
.B jump [\fIaddr\fR]
Run code at address specified.
.TP
.B load \fIfilename\fR [\fIaddr\fR]
Load program into memory emulating Kernal load routine.
.TP
.B memory [\fIaddr\fR] [\fIend|+len\fR]
Displays memory dump in hex format.
.TP
.B registers [\fIregisters\fR]
Show or change the 6510 registers (PC AC AX YR PF SP).
.TP
.B save \fIfilename\fP \fIaddr\fR \fIend|+len\fR
Saves memory area.
.TP
.B transfer \fIstart\fR \fIend|+len\fR \fIdest\fR
Moves a memory area.
.TP
.B undump \fI[filename]\fR
Loads ram image from a file.
.TP
.B x
Exits the Monitor. I.e. returns to emulator.
.TP
.B quit
Exits the \fIx64\fR
.br
.TP 8
Note: All commands may be abbreviated.

.SH DISK DRIVE
.IR X64
offers you also disk drive emulator which can also be compiled as a
separate program. The 1541 emulation uses now binary files of
length 170kb as floppy disks.
Currently, PRG and SEQ file types as well as block operations are
supported.
.LP
To create such a disk use separate command
.IR c1541
.LP
.PD 1
.TP 16
.B c1541 \fIoption\fR \fIdiskname\fR \fIparameters\fR
.TP
The following commands are supported on c1541:
.B c1541 \-f \fIdiskname\fR name,id
Format \fIdiskname\fR. Creates the file if needed.
.TP
.B c1541 \-d \fIdiskname\fR files
Delete files from \fIdiskname\fR
.TP
.B c1541 \-l \fIdiskname\fR
List files on \fIdiskname\fR
.TP
.B c1541 \-c \fIdiskname\fR \fIdump\fR
Make disk \fIdiskname\fR out of raw blockdump (683 blocks 256 bytes each).
.TP
.B c1541 \-v \fIdiskname\fR
Validate disk
.TP
.B c1541 \-i \fIdiskname\fR
Show \fIdiskname\fR and 1541 version.
.TP
.B c1541 \-r \fIdiskname\fR 1541name fsname
Read 1541name on \fIdiskname\fR to file fsname
.TP
.B c1541 -w \fIdiskname\fR \fIfsname\fR \fI1541name\fR
Write file \fIfsname\fR to \fIdiskname\fR.
.pp
.SS Examples
.BD 0
.TP 8
First\, a disk image has to be formatted in file\, say test.dsk:
.B c1541 -f test.dsk 'DISKI,ID'
.TP
to move programs to it one may type e.g.:
.B c1541 -w test.dsk pieces_of_light PIECESOFLIGHT
.TP
Finally\, start emulator with option:
.B x64 -f test.dsk
.TP
or use the monitor command
.B floppy test.dsk
.TP
After that you can load programs in emulator with simple 
.B LOAD "$",8
.br
.B LOAD "PIECESOFLIGHT",8
.B etc.

.SH FILES
.PD 0
.TP 16
.B basic
C64 BASIC ROM Routines
.TP
.B kernel
C64 KERNEL ROM Routines
.TP
.B ram
Completed execution RAM Image
.TP
.B exrom
Cartridge ROM Image
.TP
.B reu
RAM Expansion Image
.br
The REU size can be defined at compilation time to 128, 256 or 512 KB.
.TP
.B inst
Debug information about executed program.

.SH SEE ALSO
.LP
.BR sed (1),
.BR tr (1),
.BR vi (1),
.BR X (1),
.BR "\fIX Toolkit documentation\fR", 
.BR ASCII (7)

.SH BUGS
.LP
Since this program is under development
bugs are included for free.
.br
Please send your patches and bug fixes to sonninen@lut.fi.

.SH RESTRICTIONS
.LP
C64 basic and kernel are copyrighted to commodore, and thus not included
in the emulator. You have to grab your own copy of them.

To prevent fatal shock hazard do not disassemble nor hexdump this program.
No user crackable routines inside.

.SH COPYRIGHT
Copyright (c) 1993  Jarkko Sonninen, Teemu Rantanen and Jouko Valta.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
.br

.SH AUTHORS
 Jarkko Sonninen (sonninen@lut.fi)
 Jouko Valta     (jopi@stekt.oulu.fi)
 Teemu Rantanen  (tvr@cs.hut.fi)

.SH THANKS TO
 Vesa-Matti Puro (vmp@lut.fi)
 Hannu Helminen  (dm@stekt.oulu.fi)
 Richard Hable   (k3027e7@edvz.uni-linz.ac.at)
 Frank Prindle   (Frank.Prindle@lambada.oit.unc.edu)
